package dk;

import java.net.URL;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;


public class Test {

   static final Logger LOG = Logger.getLogger(Test.class);
   private static final QName SERVICE_NAME = new QName("urn:sap-com:document:sap:soap:functions:mc-style", "ZS_MM_GET_OPEN_PO");

   ZSMMGETOPENPO_Service service;

   private void setCredentials(BindingProvider bp) {
      bp.getRequestContext().put(BindingProvider.USERNAME_PROPERTY, "user");
      bp.getRequestContext().put(BindingProvider.PASSWORD_PROPERTY, "pass");
   }

   public static void main(String[] a) {
      BasicConfigurator.configure();
      Test t = new Test();
      t.run();
   }

   public void run() {
      LOG.info("start getOffeneBestellungen...");
      URL wsdlURL = ZSMMGETOPENPO_Service.WSDL_LOCATION;
      try {

         service = new ZSMMGETOPENPO_Service(wsdlURL, SERVICE_NAME);
         ZSMMGETOPENPO port = service.getZSMMGETOPENPO();
         setCredentials((BindingProvider) port);

         LOG.debug("Invoking zMmGetOpenPo...");
         String _zMmGetOpenPo_iEbeln = "";
         String _zMmGetOpenPo_iLiefertagB = "";
         String _zMmGetOpenPo_iLiefertagV = "";
         String _zMmGetOpenPo_iLifnr = "";
         String _zMmGetOpenPo_iName = "";
         String _zMmGetOpenPo_iWerks = "0046";

         Holder<ZmmEkgrpT> ekGrp = new Holder<ZmmEkgrpT>();
         Holder<ZmmEkusrT> ekUser = new Holder<ZmmEkusrT>();
         Holder<ZmmPodataT> poData = new Holder<ZmmPodataT>();

         port.zMmGetOpenPo(_zMmGetOpenPo_iEbeln, _zMmGetOpenPo_iLiefertagB, _zMmGetOpenPo_iLiefertagV,
               _zMmGetOpenPo_iLifnr, _zMmGetOpenPo_iName, _zMmGetOpenPo_iWerks, ekGrp, ekUser, poData);

         List<ZmmEkgrp> lstGrp = ekGrp.value.getItem();
         List<ZmmEkusr> lstUser = ekUser.value.getItem();

         for (ZmmPodata pl : poData.value.getItem()) {

            for (ZmmPohead ph : pl.getTHead().getItem()) {
               for (ZmmPoitem pi : ph.getTItem().getItem()) {
                  LOG.debug(pi.txz01);
               }
            }
         }

      } catch (SOAPFaultException sfex) {
         sfex.printStackTrace();
         LOG.warn(sfex);
      } finally {
      }

      return;
   }

}
